/****************************************************
* PIC-P28 with PIC16F876A PWM TestvOAGR[_AVZOLEDgp
*  ^C}0̊荞ݎgp(8bit)
*  ^C}00.5bɂ
*  ZOg_CI[hP0.5bԊuŐl\
*  AvXJjJ[^[GR[_gp
****************************************************/
#include  <16f876a.h>
#fuses	HS,PUT
#fuses	NOWDT,
#fuses	NODEBUG,NOLVP,
#fuses	NOPROTECT,NOCPD,
#fuses	NOWRT,
#use delay(clock=2000000)
#use fast_io(a)
#use fast_io(c)
//#define Cmode 0x			//port C initial mode all output
//#byte port_a = 5

////  ϐ
int Counter;
int Key_Flag;
int Prev;
int direct,duty;
static int  NUMBER = 0;         //\plJE^
static int  Digit;                  // ʉʐؑփtO
//static int  Buzzer = 0;                  // 
//BCDZOgf[^ւ̕ϊe[u(Am[hR)
int const LED_SEG[11] = {0x81, 0xF3, 0x49, 0x61, 0x33, 0x25,
                            0x05, 0xF1, 0x01, 0x31, 0x7F};

///// ^C}0荞ݏ
#int_timer0
void isr0(void)
{
    set_timer0(0xFF00);             // ^C}0Đݒ 
    if(Digit == 1)                     // ʌ̏ꍇ
    {
    Digit = 0;                     // tOؑ
    output_low(PIN_A0);                     // offAʌon
    output_high(PIN_A1);                     // 
    output_B(LED_SEG[(NUMBER / 10)]);   // ZOgf[^ɕϊEo
    }
    else                                    // ʌ̏ꍇ
    {
    Digit = 1;                    // tOؑ
    output_high(PIN_A0);                     // onAʌoff
    output_low(PIN_A1);                     // 
    output_B(LED_SEG[(NUMBER % 10)]);         // ZOgf[^ɕϊEo
    }
}

//// C[v
void main()
{
    //o͐ݒ
    output_B(0x0);                  // |[gBNA
    output_high(PIN_A0);                   // P
    NUMBER = 50;
    Digit = 0;
    set_tris_a(0xFC);	//2rbgóÂ͓
    // ^C}0ݒ
    setup_timer_0(RTCC_INTERNAL | RTCC_DIV_256);
    set_timer0(0xFF00);              // ^C}0ݒ
    enable_interrupts(INT_TIMER0);   // ^C}0荞݋
    enable_interrupts(GLOBAL);       // O[o荞݋
    /// 荞ݑ҂ACh[v  
	setup_adc_ports(NO_ANALOGS);	
	//Prev=0;
	set_tris_c(0x80);
	output_low(pin_c3);
	output_low(pin_c4);
	setup_ccp1(ccp_pwm);
	setup_ccp2(ccp_pwm);
	setup_timer_2(T2_DIV_BY_1,0x3f,1);
	prev=50;
	
	while(1)							//iv[v RE for RA2,3
    	{
		if(((input_A() & 0x04) == 0) | (Key_Flag==1)) {
			//delay_us(700);	//delay for chatter
			if(((input_A() & 0x04) == 0) | (Key_Flag==1)) {
				Key_Flag=1;
				if((input_A() & 0x04) == 0x04)	{
					delay_us(700);	//delay for chatter
					if((input_A() & 0x04) == 0x04) {
						if((input_A() & 0x08)==0x08) {
							Number=Number-1;
						}
						else {
							Number=Number+1;
						}
						Key_Flag=0;	
					}
				}
			}
		}
		if(number<50) {	
			output_low(pin_c4);
			set_pwm2_duty(256);
			set_pwm1_duty(number);	//duty max =256, 8bits
			output_high(pin_c3);
		}
		if(number>50) {	
			output_low(pin_c3);
			set_pwm1_duty(256);
			set_pwm2_duty(100-number);
			output_high(pin_c4);
		}	
     }
}
